package x5table_;

import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class Test {
	static String nameOracle = "ylcois";
	static String passwordOracle = "ylcois";
	static String urlOracle = "jdbc:oracle:thin:@192.168.88.25:1521:orcl";
	static String driverOracle = "oracle.jdbc.driver.OracleDriver";
	
	public static ResultSet execSqlSelect(String ksql, Connection conn, String sql, List<Object> binds) throws SQLException {
		PreparedStatement stmt = null;
		long cur = System.currentTimeMillis();

		try {
			stmt = conn.prepareStatement(sql);
			setParameters(stmt, binds);
			ResultSet rs = stmt.executeQuery();
			while (rs.next()) {
				System.out.println(rs.getInt(1));				
			}
			return rs;
		} catch (Exception e) {
			throw new RuntimeException(e);
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {

				}
			}
			long time = (System.currentTimeMillis() - cur);
			System.out.println("sql 执行时间：" + time + "ms");
		}

	}

	public static void setParameters(PreparedStatement stmt, List<Object> binds) throws SQLException, IOException {
		int i = 0;
		for (Object o : binds) {
			if (o == null)
				stmt.setNull(++i, getNullType());
			else if (o instanceof InputStream) {
				stmt.setBinaryStream(++i, ((InputStream) o), ((InputStream) o).available());
			} else if (o instanceof BigDecimal) {
				// stmt.setDouble(++i, ((BigDecimal) o).doubleValue());
				stmt.setBigDecimal(++i, (BigDecimal) o);
			} else if (o instanceof Blob) {
				InputStream in = ((Blob) o).getBinaryStream();
				stmt.setBinaryStream(++i, in, in.available());
			} else if (o instanceof Clob) {
				InputStream in = ((Clob) o).getAsciiStream();
				stmt.setBinaryStream(++i, in, in.available());
			} else {
				stmt.setObject(++i, o);
			}
		}
	}

	private static int getNullType() {
		return java.sql.Types.NULL;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 自动生成的方法存根
		
		String sql = "SELECT count(*) FROM SA_Task SA_Task" + 
				" WHERE ((SA_Task.SCREATETIME >= to_date(?, 'yyyy-mm-dd')) AND" + 
				"       (SA_Task.SCREATETIME < to_date(?, 'yyyy-mm-dd')))" + 
				"   AND ((? LIKE SA_Task.SEXECUTORFID || ?) AND" + 
				"       (SA_Task.SEXECUTORFID LIKE ?) AND" + 
				"       ((SA_Task.SSTATUSID = ?) OR (SA_Task.SSTATUSID = ?)))" + 
				"   AND ((SA_Task.SPROCESS <> ?) AND (SA_Task.SPROCESS <> ?) AND" + 
				"       (SA_Task.SPROCESS <> ?) AND (SA_Task.SPROCESS <> ?) AND" + 
				"       (SA_Task.SPROCESS <> ?) AND (SA_Task.SPROCESS <> ?) AND" + 
				"       (SA_Task.SPROCESS <> ?) AND (SA_Task.SPROCESS <> ?) AND" + 
				"       (SA_Task.SPROCESS <> ?))";
		String kSql = "";
		try {
		Class.forName(driverOracle);
		// 连接数据库
		Connection connO = DriverManager.getConnection(urlOracle,
				nameOracle, passwordOracle);
		
		List<Object> list = new ArrayList<Object>(){
			{
				this.add(0, "2021-01-01");
				this.add(1, "2022-01-01");
				this.add(2, "/E93A43058AD540C191CEDC9B6C79E940.ogn/E50E5280492B4985A4AE5DFA42E7B03F.ogn/D19D2BA5B4914B02999AF6B8013E6F0B.ogn/4E09DD241F47454F86399EC1EE08E65B.dpt/E779FBBA59AD4872AA1D42C927505EEF.dpt/17943E0545544214B765DCF4BE6D813B.dpt/B20ADBC91E794704A2AAB23D5DCB388F.pos/6E52B06767DE44B49B0A1C2FFFF466F8@B20ADBC91E794704A2AAB23D5DCB388F.psm");
				this.add(3, "%");
				this.add(4, "%");
				this.add(5, "tesReady");
				this.add(6, "tesExecuting");
				this.add(7, "/subSRM/quality/process/qualityImproving/qualityImprovingProcess");
				this.add(8, "/subSRM/quality/process/SupplierQuality/supplierQualityProcess");
				this.add(9, "/subSRM/priceControl/process/quotationApply/quotationApplyProcess");
				this.add(10, "/subSRM/Settlement/process/createFinalStatementProcess/createFinalStatementProcess");
				this.add(11, "/subSRM/order/process/orderModifyApply/orderModifyApplyProcess");
				this.add(12, "/subSRM/freightTransport/process/freightTransport/freightTransportProcess");
				this.add(13, "/subSRM/priceControl/process/adjustPriceApply/adjustPriceApplyProcess");
				this.add(14, "/subSRM/priceControl/process/quotationApplyS/quotationApplySProcess");
				this.add(15, "/subSRM/supplierInfo/process/supplierAssessment/supplierAssessmentProcess");
			}			
		};

		execSqlSelect(kSql,connO,sql,list);
		
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
